/**************************************************************************
                             aggir.cpp  -  description
                               -------------------
        begin                  : 2003-07-06
        copyright              : (C) 2003 by Grard Delafond & Joris Marcillac
        email                  : gerard@delafond.org & joris@marcillac.com
**************************************************************************/
/**************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
*   Library General Public License for more details.                      *
*                                                                         *
*   You should have received a copy of the GNU Library General Public     *
*   License along with this library; if not, write to the Free            *
*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,       *
*   MA 02111-1307, USA                                                    *
*                                                                         *
**************************************************************************/
#include <qglobal.h>
#include <qstring.h>
#include "aggir.h"

int CAggir::dataAGGIR [note][rub][groupe]={
    {{ 0, 0, 0, 0, 0, 0, 0, 0 },             // Cohrence
    { 0, 0, 0, 0, 0, 0, 0, 0 },            // Orientation
    { 0, 0, 0, 0, 0, 0, 0, 0 },    // Toilette
    { 0, 0, 0, 0, 0, 0, 0, 0 },    // Habillement
    { 0, 0, 0, 0, 0, 0, 0, 0 },   // Alimentation
    { 0, 0, 0, 0, 0, 0, 0, 0 },    // Elimination
    { 0, 0, 0, 0, 0, 0, 0, 0 }, // Transfert
    { 0, 0, 0, 0, 0, 0, 0, 0 },                // Dplacement interne
    { 0, 0, 0, 0, 0, 0, 0, 0 },                // Dplacement externe
    { 0, 0, 0, 0, 0, 0, 0, 0 }},           // Communication
    
    {{ 0, 320, 0, 0, 0, 100, 0, 0 },             // Cohrence
    { 0, 120, 0, 0, 0, 100, 0, 0 },            // Orientation
    { 16, 16, 16, 0, 100, 100, 200, 2000 },    // Toilette
    { 16, 16, 16, 0, 100, 100, 200, 2000 },    // Habillement
    { 20, 0, 20, 200, 100, 100, 200, 2000 },   // Alimentation
    { 16, 16, 20, 200, 100, 100, 200, 2000 },    // Elimination
    { 120, 120, 200, 200, 100, 100, 200, 2000 }, // Transfert
    { 32, -40, 40, 0, 0, 0, 100, 1000 },                // Dplacement interne
    { 0, 0, 0, 0, 0, 0, 0, 0 },                // Dplacement externe
    { 0, 0, 0, 0, 0, 0, 0, 0 }},            // Communication

    {{ 2000, 1500, 0, 0, 400, 200, 150, 0 },             // Cohrence
    { 1200, 1200, 0, 0, 400, 200, 150, 0 },            // Orientation
    { 40, 40, 40, 0, 400, 500, 300, 3000 },    // Toilette
    { 40, 40, 40, 0, 400, 500, 300, 3000 },    // Habillement
    { 60, 60, 60, 2000, 400, 500, 500, 3000 },   // Alimentation
    { 100, 100, 160, 400, 800, 500, 500, 3000 },    // Elimination
    { 800, 800, 1000, 2000, 800, 500, 400, 1000 }, // Transfert
    { 200, -80, 400, 200, 200, 200, 200, 1000 },                // Dplacement interne
    { 0, 0, 0, 0, 0, 0, 0, 0 },                // Dplacement externe
    { 0, 0, 0, 0, 0, 0, 0, 0 }}           // Communication
};

CAggir::CAggir()
{
    reinit();
}

CAggir::~CAggir()
{
}

void CAggir::setCurrentByDataAGGIR( int code, int numRub )
{
     Q_ASSERT( code < note );
     Q_ASSERT( numRub < rub );
     for ( int i = 0 ; i < groupe; ++i ) 
          current[numRub][i] = dataAGGIR[code][numRub][i];
          
#if defined(QT_DEBUG)
    QString result = "\ndataAGGIR is :\n";
    for ( int k = 0; k < rub; ++k ) {
        for (int j = 0; j < groupe; ++j) {
                result += QString::number( current[k][j] );
                result += " ";
        }
        qDebug("%s ", result.latin1() ); 
        result = "";
    }
#endif
}

void CAggir::setSigma()
{
    int sig = 0;
    
    for ( int i = 0; i < groupe; ++i ) {
        for (int j = 0; j < rub; ++j) {
                sig += current[j][i];
        }
        sigma[i] = sig;
        sig = 0;
    }
#if defined(QT_DEBUG)
    QString result = "\nSigma is :";
    for ( int k = 0; k < groupe; ++k ) {
        result += QString::number( sigma[k] );
        result += " ";
    }
    qDebug("%s ", result.latin1() ); 
#endif
}

bool CAggir::isGroupA( int value )
{   
    m_rang = 0;
    
    if ( value >= 4380 )
        m_rang = 1;
    else if ( value >= 4140 && value < 4380 )
        m_rang  = 2;
    else if ( value >= 3390 && value < 4140 )
        m_rang  = 3;
#if defined(QT_DEBUG)
    qDebug("isGroupA give m_rang = %i", m_rang ); 
#endif    
    return ( m_rang != 0 );
}

bool CAggir::isGroupB( int value )
{   
    m_rang = 0;
    
    if ( value >= 2016 )
        m_rang = 4;
#if defined(QT_DEBUG)
    qDebug("isGroupB give m_rang = %i", m_rang ); 
#endif    
    return ( m_rang != 0 );
}

bool CAggir::isGroupC( int value )
{   
    m_rang = 0;
    
    if ( value >= 1700 )
        m_rang = 5;
    else if ( value >= 1532 && value < 1700 )
        m_rang  = 6;
#if defined(QT_DEBUG)
    qDebug("isGroupC give m_rang = %i", m_rang ); 
#endif 
    return ( m_rang != 0 );
}

bool CAggir::isGroupD( int value )
{   
    m_rang = 0;
    
    if ( value >= 2400 )
        m_rang = 7;
#if defined(QT_DEBUG)
    qDebug("isGroupD give m_rang = %i", m_rang ); 
#endif 
    return ( m_rang != 0 );
}

bool CAggir::isGroupE( int value )
{   
    m_rang = 0;
    
    if ( value >= 1200 )
        m_rang = 8;
#if defined(QT_DEBUG)
    qDebug("isGroupE give m_rang = %i", m_rang ); 
#endif 
    return ( m_rang != 0 );
}

bool CAggir::isGroupF( int value )
{   
    m_rang = 0;
    
    if ( value >= 800 )
        m_rang = 9;
#if defined(QT_DEBUG)
    qDebug("isGroupF give m_rang = %i", m_rang ); 
#endif 
    return ( m_rang != 0 );
}

bool CAggir::isGroupG( int value )
{   
    m_rang = 0;
    
    if ( value >= 650 )
        m_rang = 10;
#if defined(QT_DEBUG)
    qDebug("isGroupG give m_rang = %i", m_rang ); 
#endif 
    return ( m_rang != 0 );
}

bool CAggir::isGroupH( int value )
{   
    m_rang = 0;
    
    if ( value >= 4000 )
        m_rang = 11;
    else if ( value >= 2000 && value < 4000 )
        m_rang  = 12;
    else if ( value < 2000 )
        m_rang  = 13;
#if defined(QT_DEBUG)
    qDebug("isGroupH give m_rang = %i", m_rang ); 
#endif 
    return ( m_rang != 0 );
}

void CAggir::setRang()
{
    if ( isGroupA( sigma[0] ) )
        return;
    else if ( isGroupB( sigma[1] ) )
        return;
    else if ( isGroupC( sigma[2] ) )
        return;
    else if ( isGroupD( sigma[3] ) ) 
        return;        
    else if ( isGroupE( sigma[4] ) ) 
        return;        
    else if ( isGroupF( sigma[5] ) ) 
        return;        
    else if ( isGroupG( sigma[6] ) ) 
        return;        
    else if ( isGroupH( sigma[7] ) ) 
        return;        
}

void CAggir::setGir()
{
    if ( m_rang == 1 )
        m_gir = 1;
    else if ( m_rang == 2 || m_rang == 3 || m_rang == 4 
        || m_rang == 5 || m_rang == 6 || m_rang == 7)
        m_gir = 2;
    else if ( m_rang == 8 || m_rang == 9 )
        m_gir = 3;
    else if ( m_rang == 10 || m_rang == 11 )
        m_gir = 4;
    else if ( m_rang == 12 )
        m_gir = 5;
    else if ( m_rang == 13 )
        m_gir = 6;
    else
        m_gir = 0; // error !!!
#if defined(QT_DEBUG)
    qDebug("setGir give m_gir = %i", m_gir ); 
#endif 
}

int CAggir::Gir( bool recalcul )
{
    if ( recalcul ) {
        setSigma();
        setRang();
        setGir();
    }
    
    return m_gir;
}
    
void CAggir::reinit()
{
    memset( current, 0, sizeof(current) );
    memset( sigma, 0, sizeof(sigma) );
    m_rang = 0;
    m_gir = 0 ;
}

