/**************************************************************************
                                                  main.cpp  -  description
                                                         -------------------
        begin                            : 2002-03-22 16:40:52
        copyright                        : (C) 2003 by Grard Delafond & Joris Marcillac
        email                            : gerard@delafond.org & joris@marcillac.com
**************************************************************************/
/**************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*       This program is distributed in the hope that it will be useful,           *
*       but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
*       Library General Public License for more details.                                          *
*                                                                         *
*       You should have received a copy of the GNU Library General Public         *
*       License along with this library; if not, write to the Free                        *
*       Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,       *
*       MA 02111-1307, USA                                                                                                        *
*                                                                         *
**************************************************************************//****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include <qtabwidget.h>
#include "helpform.h"


void AGGIRForm::calculateGIR()
{
    QString result = QString::number( aggir.Gir() );
    resultLineEdit->setText( result );
}

void AGGIRForm::resetSlot()
{
    resultLineEdit->setText( "6" );
    
    coherenceARadioButton->setChecked( true );
    orientationARadioButton->setChecked( true );
    toiletteARadioButton->setChecked( true );
    habillageARadioButton->setChecked( true );
    alimentationARadioButton->setChecked( true );
    EliminationARadioButton->setChecked( true );
    transfertARadioButton->setChecked( true );
    deplactintARadioButton->setChecked( true );
    deplactsextARadioButton->setChecked( true );
    communicationRadioButton->setChecked( true );
    
    aggir.reinit();
}


void AGGIRForm::helpSlot()
{
helpForm* helpDlg = new helpForm(this);
helpDlg->helpTabWidget->setCurrentPage ( 5 );
helpDlg->show();
}


void AGGIRForm::setCoherenceSlot()
{
    if ( coherenceARadioButton->isChecked() )
	    aggir.setCoherence( CAggir::A );
	else if ( coherenceBRadioButton->isChecked() )
		aggir.setCoherence( CAggir::B );
	else if ( coherenceCRadioButton->isChecked() )
		aggir.setCoherence( CAggir::C );
	
	calculateGIR();
}


void AGGIRForm::setOrientationSlot()
{
    if ( orientationARadioButton->isChecked() )
	    aggir.setOrientation( CAggir::A );
	else if ( orientationBRadioButton->isChecked() )
		aggir.setOrientation( CAggir::B );
	else if ( orientationCRadioButton->isChecked() )
		aggir.setOrientation( CAggir::C );
	
	calculateGIR();
}


void AGGIRForm::setToiletteSlot()
{
    if ( toiletteARadioButton->isChecked() )
	    aggir.setToilette( CAggir::A );
	else if ( toiletteBRadioButton->isChecked() )
		aggir.setToilette( CAggir::B );
	else if ( toiletteCRadioButton->isChecked() )
		aggir.setToilette( CAggir::C );
	
	calculateGIR();
}


void AGGIRForm::setHabillementSlot()
{
    if ( habillageARadioButton->isChecked() )
	    aggir.setHabillement( CAggir::A );
	else if ( habillageBRadioButton->isChecked() )
		aggir.setHabillement( CAggir::B );
	else if ( habillageCRadioButton->isChecked() )
		aggir.setHabillement( CAggir::C );
	
	calculateGIR();
}


void AGGIRForm::setAlimentationSlot()
{
    if ( alimentationARadioButton->isChecked() )
	    aggir.setAlimentation( CAggir::A );
	else if ( alimentationBRadioButton->isChecked() )
		aggir.setAlimentation( CAggir::B );
	else if ( alimentationCRadioButton->isChecked() )
		aggir.setAlimentation( CAggir::C );
	
	calculateGIR();
}


void AGGIRForm::setEliminationSlot()
{
    if ( EliminationARadioButton->isChecked() )
	    aggir.setElimination( CAggir::A );
	else if ( eliminationBRadioButton->isChecked() )
		aggir.setElimination( CAggir::B );
	else if ( EliminationCRadioButton->isChecked() )
		aggir.setElimination( CAggir::C );
	
	calculateGIR();
}


void AGGIRForm::setTransfertSlot()
{
    if ( transfertARadioButton->isChecked() )
	    aggir.setTransfert( CAggir::A );
	else if ( transfertBRadioButton->isChecked() )
		aggir.setTransfert( CAggir::B );
	else if ( TransfertCRadioButton->isChecked() )
		aggir.setTransfert( CAggir::C );
	
	calculateGIR();
}


void AGGIRForm::setDeplacementInterneSlot()
{
    if ( deplactintARadioButton->isChecked() )
	    aggir.setDeplacementInterne( CAggir::A );
	else if ( deplactintrRadioButton->isChecked() )
		aggir.setDeplacementInterne( CAggir::B );
	else if ( deplactintrCRadioButton->isChecked() )
		aggir.setDeplacementInterne( CAggir::C );
	
	calculateGIR();
}


void AGGIRForm::setDeplacementExterneSlot()
{
    if ( deplactsextARadioButton->isChecked() )
	    aggir.setDeplacementExterne( CAggir::A );
	else if ( deplactsextBRadioButton->isChecked() )
		aggir.setDeplacementExterne( CAggir::B );
	else if ( deplactsextCRadioButton->isChecked() )
		aggir.setDeplacementExterne( CAggir::C );
	
	calculateGIR();
}


void AGGIRForm::setCommunicationSlot()
{
    if ( communicationRadioButton->isChecked() )
	    aggir.setCommunication( CAggir::A );
	else if ( communicationBRadioButton->isChecked() )
		aggir.setCommunication( CAggir::B );
	else if ( communicationCRadioButton->isChecked() )
		aggir.setCommunication( CAggir::C );
	
	calculateGIR();
}

