/**************************************************************************
                                                  main.cpp  -  description
                                                         -------------------
        begin                            : 2002-03-22 16:40:52
        copyright                        : (C) 2003 by Grard Delafond & Joris Marcillac
        email                            : gerard@delafond.org & joris@marcillac.com
**************************************************************************/
/**************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*       This program is distributed in the hope that it will be useful,           *
*       but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
*       Library General Public License for more details.                                          *
*                                                                         *
*       You should have received a copy of the GNU Library General Public         *
*       License along with this library; if not, write to the Free                        *
*       Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,       *
*       MA 02111-1307, USA                                                                                                        *
*                                                                         *
**************************************************************************//****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include <qtabwidget.h>
#include "helpform.h"

void CockroftForm::calculateClerance()
{
    // Retrieve the inputs
    double creatinine =creatLineEdit ->text().toDouble() ;
    int weight=weightSpinBox ->value() ;
    int age=ageSpinBox ->value() ;
    bool unit = mgRadioButton->isChecked() ;
    bool sex = maleRadioButton->isChecked() ;
    double clear ;
    
    if ( unit == 1 ){
	//male
	if ( sex == 1 )
	    clear = ( 140 - age ) * weight / ( 7.2 * creatinine ) ;
	//female
	else
	    clear = 0.85 * ( 140 - age ) * weight / ( 7.2 * creatinine ) ;
    }
    else {
	if (sex == 1 )
	    clear = ( 140 - age ) * weight / ( 0.814 * creatinine ) ;
	else
	    clear = 0.85 * (140-age) * weight / ( 0.814 * creatinine) ;
    }
    // set the result
    int decimals = decimalSpinBox->value();
    clearanceResultText->setText( QString::number( clear, 'f', decimals ) );
    //what they mean
    if ( sex==1 )
       if ( clear>=97 )
	commentTextLabel -> setText (tr( ": normal") );
    else
	commentTextLabel->setText (tr( ": renal failure" ));
    else
       if ( clear>=88)
	commentTextLabel -> setText (tr( ": normal") );
    else
	commentTextLabel->setText (tr( ": renal failure" ));
	
}

#include <qvalidator.h>
void CockroftForm::init()
{ 
    creatLineEdit->setValidator( new QDoubleValidator(  creatLineEdit  ) );
    //    lineEditCreat->setText( "10" );
    calculateClerance();
    creatLineEdit ->selectAll();
}


void CockroftForm::resetSpinBoxSlot()
{
    creatLineEdit->setText( "10" );
    mgRadioButton->setChecked( true ) ;
    maleRadioButton->setChecked( true ) ;
//    creatLineEdit->setValidator( 50 );
    weightSpinBox ->setValue(50);
    ageSpinBox ->setValue(50);
}


void CockroftForm::helpSlot()
{
helpForm* helpDlg = new helpForm(this);
helpDlg->helpTabWidget->setCurrentPage ( 2 );
helpDlg->show();
}
