/**************************************************************************
                                                  main.cpp  -  description
                                                         -------------------
        begin                            : 2002-03-22 16:40:52
        copyright                        : (C) 2003 by Grard Delafond & Joris Marcillac
        email                            : gerard@delafond.org & joris@marcillac.com
**************************************************************************/
/**************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*       This program is distributed in the hope that it will be useful,           *
*       but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
*       Library General Public License for more details.                                          *
*                                                                         *
*       You should have received a copy of the GNU Library General Public         *
*       License along with this library; if not, write to the Free                        *
*       Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,       *
*       MA 02111-1307, USA                                                                                                        *
*                                                                         *
**************************************************************************//****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include <qtabwidget.h>
#include <qmessagebox.h>
#include "helpform.h"

void FriedwaldForm::calculateIndex()
{
    // Retrieve the inputs
    double cholesterol = cholesterolLineEdit->text().toDouble();
    double HDL = HDLLineEdit->text().toDouble();
    double trigly = triglyLineEdit->text().toDouble();
    bool unit = grammeRadioButton->isChecked();
    
    if (unit ==1)
    {    if ( trigly < 0 || trigly > 5 ) {
	    QMessageBox::warning( this, tr( "Out of range" ), tr( "The range of triglycerids should be between 0 and 5." ), QMessageBox::Ok, 0 );
	    triglyLineEdit->setText( "1" );
	    triglyLineEdit->setFocus();
	    return;
	}
    }
    else
    {    if ( trigly < 0 || trigly > 6 ) {
	    QMessageBox::warning( this, tr( "Out of range" ), tr( "The range of triglycerids should be between 0 and 6." ), QMessageBox::Ok, 0 );
	    triglyLineEdit->setText( "1" );
	    triglyLineEdit->setFocus();
	    return;
	}
    }       
    
    int decimals = decimalSpinBox->value();
    
    
    //conversion
    double LDL;
    if (unit==1)
	LDL = ( cholesterol ) - ( HDL ) - ( trigly ) / 5 ;
    else
	LDL = ( cholesterol ) - ( HDL ) - ( trigly ) / 2.2 ; 
    
    // set the result   
    LDLResultLabel->setText( QString::number( LDL, 'f', decimals )  );
    //show the unit   
    if (unit==1)
	unitTextLabel -> setText( "g/L" );
    else
	unitTextLabel->setText( "mmol/L" );
  }
#include <qvalidator.h>
void FriedwaldForm::init()
    {
        cholesterolLineEdit->setValidator( new QDoubleValidator( cholesterolLineEdit )  );
        cholesterolLineEdit->setText( "2" );
        HDLLineEdit->setValidator( new QDoubleValidator( HDLLineEdit )  );
        HDLLineEdit->setText( "0.5" );
        triglyLineEdit->setValidator( new QDoubleValidator( triglyLineEdit )  );
        triglyLineEdit->setText( "1" );
         calculateIndex();
        cholesterolLineEdit->selectAll();
        HDLLineEdit->selectAll();
        triglyLineEdit->selectAll();	
}


void FriedwaldForm::helpSlot()
{
    helpForm* helpDlg = new helpForm(this);
    helpDlg->helpTabWidget->setCurrentPage ( 4 );
    helpDlg->show();
}

void FriedwaldForm::resetSlot()
{
    grammeRadioButton->setChecked( true );
    cholesterolLineEdit->setText( "2" );
    HDLLineEdit->setText( "0.5" );
    triglyLineEdit->setText( "1" );
    calculateIndex();
}
